// Connect.h : Declaration of the CConnect

#pragma once
#include "resource.h"       // main symbols
#include "CApplication.h"
#include "CCommandBarPopup.h"
#include "CCommandBarButton.h"
#include "AddIn.h"

// CConnect
class ATL_NO_VTABLE CConnect : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CConnect, &CLSID_Connect>,
	public IDispatchImpl<AddInDesignerObjects::_IDTExtensibility2, &AddInDesignerObjects::IID__IDTExtensibility2, &AddInDesignerObjects::LIBID_AddInDesignerObjects, 1, 0>,
	public IDispatchImpl<IWordFindInterface, &__uuidof(IWordFindInterface), &__uuidof(WordFindFacilityLib), /* wMajor = */ 1, /* wMinor = */ 0>
{
public:
	CConnect()
	{
	}

	DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)
	DECLARE_NOT_AGGREGATABLE(CConnect)
	DECLARE_CLASSFACTORY_SINGLETON(CConnect)

	BEGIN_COM_MAP(CConnect)
		COM_INTERFACE_ENTRY2(IDispatch, IWordFindInterface)
		COM_INTERFACE_ENTRY(AddInDesignerObjects::IDTExtensibility2)
		COM_INTERFACE_ENTRY(IWordFindInterface)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease() 
	{
	}

public:
	//IDTExtensibility2 implementation:
	STDMETHOD(OnConnection)(IDispatch * Application, AddInDesignerObjects::ext_ConnectMode ConnectMode, IDispatch *AddInInst, SAFEARRAY **custom);
	STDMETHOD(OnDisconnection)(AddInDesignerObjects::ext_DisconnectMode RemoveMode, SAFEARRAY **custom );
	STDMETHOD(OnAddInsUpdate)(SAFEARRAY **custom );
	STDMETHOD(OnStartupComplete)(SAFEARRAY **custom );
	STDMETHOD(OnBeginShutdown)(SAFEARRAY **custom );

	CComPtr<IDispatch> m_pApplication;
	CComPtr<IDispatch> m_pAddInInstance;
private:
	CApplication m_oWordApp;
	CCommandBarPopup m_oWordFindPopup;
	CCommandBarButton m_oWordFindButton;
	void AddMenuItems();
	void RemoveMenuItems();

	// IWordFindInterface Methods
public:
public:
	STDMETHOD(WordFind)(void);
};

OBJECT_ENTRY_AUTO(__uuidof(Connect), CConnect)
